# Base docker-compose to combine with
#   In devcontainer.json: "dockerComposeFile": ["docker-compose.base.yml", "docker-compose.yml"],

# intention is that this file stays as is, updated eventually,
# and variations are handled in main docker-compose.yml

services:
  devenv:
    user: dev
    build:
      context: .
      dockerfile: Dockerfile
      args:
        DOCKER_INSTALL: 0
        DOCKER_COMPOSE_INSTALL: 0
        DOCKER_GID: ${DOCKER_GID}
        DOCKER_LOGIN_USERNAME: ${DOCKER_USERNAME}
        DOCKER_LOGIN_PASSWORD: ${DOCKER_PASSWORD}
        # DOCKER_LOGIN_REGISTRY:
        GITCONFIG_USER_EMAIL: ${GIT_EMAIL}
        GITCONFIG_USER_SIGNINGKEY: ${GIT_SIGNINGKEY}
        HELM_INSTALL: 0
        HELM_LOGIN_USER: ${API_HELM_USER}
        HELM_LOGIN_PASSWORD: ${API_HELM_PASSWORD}
        #   example:  https://gitlab.com/api/v4/projects/0123456789/packages/helm/stable
        # HELM_LOGIN_REGISTRY:
        KUBECTL_INSTALL: 0
        KUBECONFIG: ${KUBECONFIG}
        NETRC_HOST: ${NETRC_HOST}
        NETRC_USER: ${NETRC_USER}
        NETRC_PASSWORD: ${NETRC_PASSWORD}
        RANCHER_INSTALL: 0
        # to define in main docker-compose.yml
        # RANCHER_LOGIN_PROJECT:
        # RANCHER_LOGIN_URL:
        RANCHER_LOGIN_TOKEN: ${RANCHER_TOKEN}
        STARSHIP_INSTALL: 0
        OHMYZSH_INSTALL: 0
        BASHRC_LOAD: 1
    volumes:
      # Set this to wherever you want VS Code to mount the folder of your project
      # - ../:/workspace:cached
      # Preserve VSCode Extensions
      - vscode_extension:/home/dev/.vscode-server/extensions
      - vscode_insider_extension:/home/dev/.vscode-server-insiders/extensions
      # Forwards the local Docker socket to the container.
      # Add this in your main docker-compose to be able to use docker within container
      # - /var/run/docker.sock:/var/run/docker.sock
    cap_add:
      - SYS_PTRACE
    security_opt:
      - seccomp:unconfined
    # Overrides default command so things don't shut down after the process ends.
    command: sleep infinity

volumes:
  vscode_extension:
  vscode_insider_extension:
